=== debian/changelog ===
qprompt (2.0.0-0ubuntu1) resolute; urgency=medium

  * New upstream version 2.0.0
  * Apply vendored QHotkey
  * Use now-upstreamed manpage
  * debian/control: Update to current dependencies for Qt6/KDE6

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Fri, 02 Jan 2026 10:51:13 -0800
