=== debian/control ===
Source: qprompt
Section: video
Priority: optional
Maintainer: Erich Eickmeyer <eeickmeyer@ubuntu.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 cmake-extras,
 extra-cmake-modules,
 qt6-base-dev,
 libkirigami-dev,,
 qml6-module-org-kde-coreaddons,
 qml6-module-qtquick-shapes,
 qt6-declarative-dev,
 libqt63drender6,
 libqt6quickshapes6,
 qt6-qmltooling-plugins,
 libqt63dcore6,
 librhash-dev,
 libqt6svg6-dev,
 cmake-data,
 qml6-module-qt-labs-qmlmodels,
 qml6-module-qtqml-statemachine,
 libqt6quicktest6,
 qml6-module-qtquick-scene2d,
 libqt63dquickscene2d6,
 qml6-module-qtquick-controls,
 qt6-shadertools-dev,
 gettext,
 libkf6auth-dev-bin,
 libkf6widgetsaddons-dev,
 libkf6iconthemes-dev,
 libkf6codecs-dev,
 libkf6guiaddons-dev,
 libkf6auth-dev,
 libkf6configwidgets-dev,
 libkf6itemviews-dev,
 libxkbcommon-dev,
 libkf6crash-dev,
Standards-Version: 4.6.1
Homepage: https://qprompt.app/
Vcs-Browser: https://github.com/Cuperino/QPrompt
Vcs-Git: https://github.com/Cuperino/QPrompt.git

Package: qprompt
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Teleprompter Software
 Personal teleprompter software for all video creators.
 Built with ease of use, productivity, control accuracy,
 and smooth performance in mind.
