=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_build:
	mv debian/vendor/QHotkey 3rdparty;
	dh_auto_build
